Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -3617,49 +3647,49 @@
     push di                                   ; 57
     mov di, ax                                ; 89 c7
-    call 02d6dh                               ; e8 ab ff
+    call 02d82h                               ; e8 ab ff
     test ax, ax                               ; 85 c0
-    jne short 02dcbh                          ; 75 05
+    jne short 02de0h                          ; 75 05
     xor cx, cx                                ; 31 c9
-    jmp near 02e99h                           ; e9 ce 00
+    jmp near 02eaeh                           ; e9 ce 00
     mov ax, strict word 00010h                ; b8 10 00
-    call 0165ch                               ; e8 8b e8
+    call 0165ch                               ; e8 76 e8
     test di, di                               ; 85 ff
-    jne short 02ddch                          ; 75 07
+    jne short 02df1h                          ; 75 07
     mov cl, al                                ; 88 c1
     shr cl, 004h                              ; c0 e9 04
-    jmp short 02de1h                          ; eb 05
+    jmp short 02df6h                          ; eb 05
     mov cl, al                                ; 88 c1
     and cl, 00fh                              ; 80 e1 0f
     cmp cl, 001h                              ; 80 f9 01
-    jne short 02defh                          ; 75 09
+    jne short 02e04h                          ; 75 09
     xor cl, cl                                ; 30 c9
     mov CH, strict byte 015h                  ; b5 15
     mov si, strict word 00001h                ; be 01 00
-    jmp short 02e2dh                          ; eb 3e
+    jmp short 02e42h                          ; eb 3e
     cmp cl, 002h                              ; 80 f9 02
-    jne short 02dfah                          ; 75 06
+    jne short 02e0fh                          ; 75 06
     xor cl, cl                                ; 30 c9
     mov CH, strict byte 035h                  ; b5 35
-    jmp short 02deah                          ; eb f0
+    jmp short 02dffh                          ; eb f0
     cmp cl, 003h                              ; 80 f9 03
-    jne short 02e05h                          ; 75 06
+    jne short 02e1ah                          ; 75 06
     xor cl, cl                                ; 30 c9
     mov CH, strict byte 017h                  ; b5 17
-    jmp short 02deah                          ; eb e5
+    jmp short 02dffh                          ; eb e5
     cmp cl, 004h                              ; 80 f9 04
-    jne short 02e10h                          ; 75 06
+    jne short 02e25h                          ; 75 06
     xor cl, cl                                ; 30 c9
     mov CH, strict byte 017h                  ; b5 17
-    jmp short 02deah                          ; eb da
+    jmp short 02dffh                          ; eb da
     cmp cl, 005h                              ; 80 f9 05
-    jne short 02e1bh                          ; 75 06
+    jne short 02e30h                          ; 75 06
     mov CL, strict byte 0cch                  ; b1 cc
     mov CH, strict byte 0d7h                  ; b5 d7
-    jmp short 02deah                          ; eb cf
+    jmp short 02dffh                          ; eb cf
     cmp cl, 00eh                              ; 80 f9 0e
-    je short 02e25h                           ; 74 05
+    je short 02e3ah                           ; 74 05
     cmp cl, 00fh                              ; 80 f9 0f
-    jne short 02e27h                          ; 75 02
-    jmp short 02e15h                          ; eb ee
+    jne short 02e3ch                          ; 75 02
+    jmp short 02e2ah                          ; eb ee
     xor cl, cl                                ; 30 c9
     xor ch, ch                                ; 30 ed
@@ -3668,32 +3698,32 @@
     mov dx, 0008bh                            ; ba 8b 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 d5 e7
+    call 0160eh                               ; e8 c0 e7
     mov ax, di                                ; 89 f8
-    call 02d2dh                               ; e8 ef fe
+    call 02d42h                               ; e8 ef fe
     test ax, ax                               ; 85 c0
-    jne short 02e74h                          ; 75 32
+    jne short 02e89h                          ; 75 32
     mov al, cl                                ; 88 c8
     and AL, strict byte 0c0h                  ; 24 c0
     cmp AL, strict byte 080h                  ; 3c 80
-    je short 02e74h                           ; 74 2a
+    je short 02e89h                           ; 74 2a
     mov al, cl                                ; 88 c8
     and AL, strict byte 0c0h                  ; 24 c0
     cmp AL, strict byte 0c0h                  ; 3c c0
-    je short 02e61h                           ; 74 0f
+    je short 02e76h                           ; 74 0f
     mov ah, cl                                ; 88 cc
     and ah, 03fh                              ; 80 e4 3f
     cmp AL, strict byte 040h                  ; 3c 40
-    je short 02e6dh                           ; 74 12
+    je short 02e82h                           ; 74 12
     test al, al                               ; 84 c0
-    je short 02e66h                           ; 74 07
-    jmp short 02e2dh                          ; eb cc
+    je short 02e7bh                           ; 74 07
+    jmp short 02e42h                          ; eb cc
     and cl, 03fh                              ; 80 e1 3f
-    jmp short 02e2dh                          ; eb c7
+    jmp short 02e42h                          ; eb c7
     mov cl, ah                                ; 88 e1
     or cl, 040h                               ; 80 c9 40
-    jmp short 02e2dh                          ; eb c0
+    jmp short 02e42h                          ; eb c0
     mov cl, ah                                ; 88 e1
     or cl, 080h                               ; 80 c9 80
-    jmp short 02e2dh                          ; eb b9
+    jmp short 02e42h                          ; eb b9
     test di, di                               ; 85 ff
     db  00fh, 095h, 0c0h
@@ -3704,9 +3734,9 @@
     mov dx, 0008bh                            ; ba 8b 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 82 e7
+    call 0160eh                               ; e8 6d e7
     movzx bx, ch                              ; 0f b6 dd
     mov dx, di                                ; 89 fa
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 77 e7
+    call 0160eh                               ; e8 62 e7
     mov cx, si                                ; 89 f1
     mov ax, cx                                ; 89 c8
@@ -3719,5 +3749,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-floppy_drive_exists_:                        ; 0xf2ea5 LB 0x24
+floppy_drive_exists_:                        ; 0xf2eba LB 0x24
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -3725,9 +3755,9 @@
     mov dx, ax                                ; 89 c2
     mov ax, strict word 00010h                ; b8 10 00
-    call 0165ch                               ; e8 ab e7
+    call 0165ch                               ; e8 96 e7
     test dx, dx                               ; 85 d2
-    jne short 02ebah                          ; 75 05
+    jne short 02ecfh                          ; 75 05
     shr al, 004h                              ; c0 e8 04
-    jmp short 02ebch                          ; eb 02
+    jmp short 02ed1h                          ; eb 02
     and AL, strict byte 00fh                  ; 24 0f
     test al, al                               ; 84 c0
@@ -3739,5 +3769,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-_int13_diskette_function:                    ; 0xf2ec9 LB 0x72a
+_int13_diskette_function:                    ; 0xf2ede LB 0x734
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -3752,37 +3782,36 @@
     mov ah, byte [bp+00eh]                    ; 8a 66 0e
     cmp bl, 008h                              ; 80 fb 08
-    jc short 02f22h                           ; 72 3a
+    jc short 02f35h                           ; 72 38
     mov dx, word [bp+01ch]                    ; 8b 56 1c
     or dl, 001h                               ; 80 ca 01
     cmp bl, 008h                              ; 80 fb 08
-    jbe near 03472h                           ; 0f 86 7d 05
+    jbe near 03491h                           ; 0f 86 87 05
     cmp bl, 016h                              ; 80 fb 16
-    jc short 02f18h                           ; 72 1e
+    jc short 02f2bh                           ; 72 1c
     or si, 00100h                             ; 81 ce 00 01
-    mov cx, si                                ; 89 f1
     cmp bl, 016h                              ; 80 fb 16
-    jbe near 035aeh                           ; 0f 86 a7 06
+    jbe near 035cdh                           ; 0f 86 b3 06
     cmp bl, 018h                              ; 80 fb 18
-    je near 035b3h                            ; 0f 84 a5 06
+    je near 035d2h                            ; 0f 84 b1 06
     cmp bl, 017h                              ; 80 fb 17
-    je near 035b3h                            ; 0f 84 9e 06
-    jmp near 035d0h                           ; e9 b8 06
+    je near 035d2h                            ; 0f 84 aa 06
+    jmp near 035efh                           ; e9 c4 06
     cmp bl, 015h                              ; 80 fb 15
-    je near 03568h                            ; 0f 84 49 06
-    jmp near 035d0h                           ; e9 ae 06
+    je near 03587h                            ; 0f 84 55 06
+    jmp near 035efh                           ; e9 ba 06
     cmp bl, 001h                              ; 80 fb 01
-    jc short 02f3ch                           ; 72 15
-    jbe near 02fb5h                           ; 0f 86 8a 00
+    jc short 02f4fh                           ; 72 15
+    jbe near 02fc8h                           ; 0f 86 8a 00
     cmp bl, 005h                              ; 80 fb 05
-    je near 032f8h                            ; 0f 84 c6 03
+    je near 0330bh                            ; 0f 84 c6 03
     cmp bl, 004h                              ; 80 fb 04
-    jbe near 02fd3h                           ; 0f 86 9a 00
-    jmp near 035d0h                           ; e9 94 06
+    jbe near 02fe6h                           ; 0f 86 9a 00
+    jmp near 035efh                           ; e9 a0 06
     test bl, bl                               ; 84 db
-    jne near 035d0h                           ; 0f 85 8e 06
+    jne near 035efh                           ; 0f 85 9a 06
     mov al, byte [bp+00eh]                    ; 8a 46 0e
     mov byte [bp-00eh], al                    ; 88 46 f2
     cmp AL, strict byte 001h                  ; 3c 01
-    jbe short 02f60h                          ; 76 14
+    jbe short 02f73h                          ; 76 14
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -3790,17 +3819,17 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov ax, strict word 00001h                ; b8 01 00
-    call 02b92h                               ; e8 35 fc
-    jmp near 032d4h                           ; e9 74 03
+    call 02ba7h                               ; e8 37 fc
+    jmp near 032e7h                           ; e9 74 03
     mov ax, strict word 00010h                ; b8 10 00
-    call 0165ch                               ; e8 f6 e6
+    call 0165ch                               ; e8 e3 e6
     cmp byte [bp-00eh], 000h                  ; 80 7e f2 00
-    jne short 02f73h                          ; 75 07
+    jne short 02f86h                          ; 75 07
     mov dl, al                                ; 88 c2
     shr dl, 004h                              ; c0 ea 04
-    jmp short 02f78h                          ; eb 05
+    jmp short 02f8bh                          ; eb 05
     mov dl, al                                ; 88 c2
     and dl, 00fh                              ; 80 e2 0f
     test dl, dl                               ; 84 d2
-    jne short 02f8ch                          ; 75 10
+    jne short 02f9fh                          ; 75 10
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -3808,17 +3837,17 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov ax, 00080h                            ; b8 80 00
-    jmp short 02f5ah                          ; eb ce
+    jmp short 02f6dh                          ; eb ce
     xor bx, bx                                ; 31 db
     mov dx, strict word 0003eh                ; ba 3e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 77 e6
+    call 0160eh                               ; e8 64 e6
     xor al, al                                ; 30 c0
     mov byte [bp+017h], al                    ; 88 46 17
     xor ah, ah                                ; 30 e4
-    call 02b92h                               ; e8 f1 fb
+    call 02ba7h                               ; e8 f3 fb
     and byte [bp+01ch], 0feh                  ; 80 66 1c fe
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     xor dx, dx                                ; 31 d2
-    call 02baah                               ; e8 fc fb
+    call 02bbfh                               ; e8 fe fb
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -3829,5 +3858,5 @@
     mov dx, 00441h                            ; ba 41 04
     xor ax, ax                                ; 31 c0
-    call 01600h                               ; e8 3f e6
+    call 01600h                               ; e8 2c e6
     movzx dx, al                              ; 0f b6 d0
     sal dx, 008h                              ; c1 e2 08
@@ -3835,34 +3864,34 @@
     mov word [bp+016h], si                    ; 89 76 16
     test al, al                               ; 84 c0
-    je short 02faeh                           ; 74 de
-    jmp near 032d4h                           ; e9 01 03
+    je short 02fc1h                           ; 74 de
+    jmp near 032e7h                           ; e9 01 03
     mov al, byte [bp+016h]                    ; 8a 46 16
     mov byte [bp-00ch], al                    ; 88 46 f4
     mov dx, word [bp+014h]                    ; 8b 56 14
     shr dx, 008h                              ; c1 ea 08
-    mov byte [bp-008h], dl                    ; 88 56 f8
+    mov byte [bp-006h], dl                    ; 88 56 fa
     mov al, byte [bp+014h]                    ; 8a 46 14
     mov byte [bp-00ah], al                    ; 88 46 f6
     mov dx, word [bp+012h]                    ; 8b 56 12
     shr dx, 008h                              ; c1 ea 08
-    mov byte [bp-006h], dl                    ; 88 56 fa
+    mov byte [bp-008h], dl                    ; 88 56 f8
     mov byte [bp-00eh], ah                    ; 88 66 f2
     cmp ah, 001h                              ; 80 fc 01
-    jnbe short 03009h                         ; 77 10
+    jnbe short 0301ch                         ; 77 10
     cmp dl, 001h                              ; 80 fa 01
-    jnbe short 03009h                         ; 77 0b
+    jnbe short 0301ch                         ; 77 0b
     mov al, byte [bp-00ch]                    ; 8a 46 f4
     test al, al                               ; 84 c0
-    je short 03009h                           ; 74 04
+    je short 0301ch                           ; 74 04
     cmp AL, strict byte 048h                  ; 3c 48
-    jbe short 03032h                          ; 76 29
-    mov bx, 00da6h                            ; bb a6 0d
+    jbe short 03045h                          ; 76 29
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 b8 e8
+    call 018e1h                               ; e8 ba e8
     push 00255h                               ; 68 55 02
     push 0026dh                               ; 68 6d 02
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 ee e8
+    call 01922h                               ; e8 f0 e8
     add sp, strict byte 00006h                ; 83 c4 06
     mov ax, word [bp+016h]                    ; 8b 46 16
@@ -3871,18 +3900,18 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov ax, strict word 00001h                ; b8 01 00
-    jmp short 030a3h                          ; eb 71
+    jmp short 030b6h                          ; eb 71
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02ea5h                               ; e8 6c fe
+    call 02ebah                               ; e8 6e fe
     test ax, ax                               ; 85 c0
-    je near 03136h                            ; 0f 84 f7 00
+    je near 03149h                            ; 0f 84 f7 00
     movzx dx, byte [bp-00eh]                  ; 0f b6 56 f2
     mov ax, dx                                ; 89 d0
-    call 02ceah                               ; e8 a2 fc
+    call 02cffh                               ; e8 a4 fc
     test ax, ax                               ; 85 c0
-    jne short 03065h                          ; 75 19
+    jne short 03078h                          ; 75 19
     mov ax, dx                                ; 89 d0
-    call 02db5h                               ; e8 64 fd
+    call 02dcah                               ; e8 66 fd
     test ax, ax                               ; 85 c0
-    jne short 03065h                          ; 75 10
+    jne short 03078h                          ; 75 10
     mov ax, word [bp+016h]                    ; 8b 46 16
     xor ah, ah                                ; 30 e4
@@ -3890,7 +3919,161 @@
     mov word [bp+016h], ax                    ; 89 46 16
     mov ax, strict word 0000ch                ; b8 0c 00
-    jmp short 030a3h                          ; eb 3e
+    jmp short 030b6h                          ; eb 3e
     cmp ch, 002h                              ; 80 fd 02
-    jne near 031cdh                           ; 0f 85 61 01
+    jne near 031e0h                           ; 0f 85 61 01
+    mov cx, word [bp+006h]                    ; 8b 4e 06
+    shr cx, 00ch                              ; c1 e9 0c
+    mov ah, cl                                ; 88 cc
+    mov dx, word [bp+006h]                    ; 8b 56 06
+    sal dx, 004h                              ; c1 e2 04
+    mov bx, word [bp+010h]                    ; 8b 5e 10
+    add bx, dx                                ; 01 d3
+    cmp bx, dx                                ; 39 d3
+    jnc short 03098h                          ; 73 02
+    db  0feh, 0c4h
+    ; inc ah                                    ; fe c4
+    movzx cx, byte [bp-00ch]                  ; 0f b6 4e f4
+    sal cx, 009h                              ; c1 e1 09
+    dec cx                                    ; 49
+    mov dx, bx                                ; 89 da
+    add dx, cx                                ; 01 ca
+    cmp dx, bx                                ; 39 da
+    jnc short 030c0h                          ; 73 18
+    mov ax, word [bp+016h]                    ; 8b 46 16
+    xor ah, ah                                ; 30 e4
+    or ah, 009h                               ; 80 cc 09
+    mov word [bp+016h], ax                    ; 89 46 16
+    mov ax, strict word 00009h                ; b8 09 00
+    call 02ba7h                               ; e8 ee fa
+    mov byte [bp+016h], 000h                  ; c6 46 16 00
+    jmp near 032e7h                           ; e9 27 02
+    mov AL, strict byte 006h                  ; b0 06
+    mov dx, strict word 0000ah                ; ba 0a 00
+    out DX, AL                                ; ee
+    xor al, al                                ; 30 c0
+    mov dx, strict word 0000ch                ; ba 0c 00
+    out DX, AL                                ; ee
+    mov al, bl                                ; 88 d8
+    mov dx, strict word 00004h                ; ba 04 00
+    out DX, AL                                ; ee
+    shr bx, 008h                              ; c1 eb 08
+    mov al, bl                                ; 88 d8
+    out DX, AL                                ; ee
+    xor al, bl                                ; 30 d8
+    mov dx, strict word 0000ch                ; ba 0c 00
+    out DX, AL                                ; ee
+    mov al, cl                                ; 88 c8
+    mov dx, strict word 00005h                ; ba 05 00
+    out DX, AL                                ; ee
+    shr cx, 008h                              ; c1 e9 08
+    mov al, cl                                ; 88 c8
+    out DX, AL                                ; ee
+    mov AL, strict byte 046h                  ; b0 46
+    mov dx, strict word 0000bh                ; ba 0b 00
+    out DX, AL                                ; ee
+    mov al, ah                                ; 88 e0
+    mov dx, 00081h                            ; ba 81 00
+    out DX, AL                                ; ee
+    mov AL, strict byte 002h                  ; b0 02
+    mov dx, strict word 0000ah                ; ba 0a 00
+    out DX, AL                                ; ee
+    out DX, AL                                ; ee
+    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
+    call 02c7eh                               ; e8 7a fb
+    mov AL, strict byte 0e6h                  ; b0 e6
+    mov dx, 003f5h                            ; ba f5 03
+    out DX, AL                                ; ee
+    movzx ax, byte [bp-008h]                  ; 0f b6 46 f8
+    sal ax, 002h                              ; c1 e0 02
+    movzx dx, byte [bp-00eh]                  ; 0f b6 56 f2
+    or ax, dx                                 ; 09 d0
+    mov dx, 003f5h                            ; ba f5 03
+    out DX, AL                                ; ee
+    mov al, byte [bp-006h]                    ; 8a 46 fa
+    out DX, AL                                ; ee
+    mov al, byte [bp-008h]                    ; 8a 46 f8
+    out DX, AL                                ; ee
+    mov al, byte [bp-00ah]                    ; 8a 46 f6
+    out DX, AL                                ; ee
+    mov AL, strict byte 002h                  ; b0 02
+    out DX, AL                                ; ee
+    movzx dx, byte [bp-00ah]                  ; 0f b6 56 f6
+    movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
+    add ax, dx                                ; 01 d0
+    dec ax                                    ; 48
+    mov dx, 003f5h                            ; ba f5 03
+    out DX, AL                                ; ee
+    xor al, al                                ; 30 c0
+    out DX, AL                                ; ee
+    mov AL, strict byte 0ffh                  ; b0 ff
+    out DX, AL                                ; ee
+    call 02c0dh                               ; e8 cb fa
+    test al, al                               ; 84 c0
+    jne short 0315ah                          ; 75 14
+    call 02c53h                               ; e8 0a fb
+    mov ax, word [bp+016h]                    ; 8b 46 16
+    xor ah, ah                                ; 30 e4
+    or ah, 080h                               ; 80 cc 80
+    mov word [bp+016h], ax                    ; 89 46 16
+    mov ax, 00080h                            ; b8 80 00
+    jmp near 030b6h                           ; e9 5c ff
+    mov dx, 003f4h                            ; ba f4 03
+    in AL, DX                                 ; ec
+    db  02ah, 0e4h
+    ; sub ah, ah                                ; 2a e4
+    and AL, strict byte 0c0h                  ; 24 c0
+    cmp AL, strict byte 0c0h                  ; 3c c0
+    je short 03174h                           ; 74 0e
+    push 00255h                               ; 68 55 02
+    push 00288h                               ; 68 88 02
+    push strict byte 00007h                   ; 6a 07
+    call 01922h                               ; e8 b1 e7
+    add sp, strict byte 00006h                ; 83 c4 06
+    xor si, si                                ; 31 f6
+    jmp short 0317dh                          ; eb 05
+    cmp si, strict byte 00007h                ; 83 fe 07
+    jnl short 03195h                          ; 7d 18
+    mov dx, 003f5h                            ; ba f5 03
+    in AL, DX                                 ; ec
+    db  02ah, 0e4h
+    ; sub ah, ah                                ; 2a e4
+    mov byte [bp+si-016h], al                 ; 88 42 ea
+    movzx bx, al                              ; 0f b6 d8
+    lea dx, [si+042h]                         ; 8d 54 42
+    mov ax, strict word 00040h                ; b8 40 00
+    call 0160eh                               ; e8 7c e4
+    inc si                                    ; 46
+    jmp short 03178h                          ; eb e3
+    test byte [bp-016h], 0c0h                 ; f6 46 ea c0
+    je short 031ach                           ; 74 11
+    mov ax, word [bp+016h]                    ; 8b 46 16
+    xor ah, ah                                ; 30 e4
+    or ah, 020h                               ; 80 cc 20
+    mov word [bp+016h], ax                    ; 89 46 16
+    mov ax, strict word 00020h                ; b8 20 00
+    jmp near 030b6h                           ; e9 0a ff
+    movzx ax, byte [bp-00ch]                  ; 0f b6 46 f4
+    sal ax, 009h                              ; c1 e0 09
+    cwd                                       ; 99
+    db  02bh, 0c2h
+    ; sub ax, dx                                ; 2b c2
+    sar ax, 1                                 ; d1 f8
+    mov si, word [bp+010h]                    ; 8b 76 10
+    mov dx, word [bp+006h]                    ; 8b 56 06
+    mov di, si                                ; 89 f7
+    mov es, dx                                ; 8e c2
+    mov cx, ax                                ; 89 c1
+    push DS                                   ; 1e
+    mov ds, dx                                ; 8e da
+    rep movsw                                 ; f3 a5
+    pop DS                                    ; 1f
+    movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
+    movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
+    call 02bbfh                               ; e8 ea f9
+    mov byte [bp+017h], 000h                  ; c6 46 17 00
+    and byte [bp+01ch], 0feh                  ; 80 66 1c fe
+    jmp near 02fc1h                           ; e9 e1 fd
+    cmp ch, 003h                              ; 80 fd 03
+    jne near 032f5h                           ; 0f 85 0e 01
     mov dx, word [bp+006h]                    ; 8b 56 06
     shr dx, 00ch                              ; c1 ea 0c
@@ -3901,5 +4084,5 @@
     add bx, cx                                ; 01 cb
     cmp bx, cx                                ; 39 cb
-    jnc short 03085h                          ; 73 02
+    jnc short 03200h                          ; 73 02
     db  0feh, 0c4h
     ; inc ah                                    ; fe c4
@@ -3910,13 +4093,5 @@
     add dx, cx                                ; 01 ca
     cmp dx, bx                                ; 39 da
-    jnc short 030adh                          ; 73 18
-    mov ax, word [bp+016h]                    ; 8b 46 16
-    xor ah, ah                                ; 30 e4
-    or ah, 009h                               ; 80 cc 09
-    mov word [bp+016h], ax                    ; 89 46 16
-    mov ax, strict word 00009h                ; b8 09 00
-    call 02b92h                               ; e8 ec fa
-    mov byte [bp+016h], 000h                  ; c6 46 16 00
-    jmp near 032d4h                           ; e9 27 02
+    jc near 030a8h                            ; 0f 82 96 fe
     mov AL, strict byte 006h                  ; b0 06
     mov dx, strict word 0000ah                ; ba 0a 00
@@ -3940,5 +4115,5 @@
     mov al, cl                                ; 88 c8
     out DX, AL                                ; ee
-    mov AL, strict byte 046h                  ; b0 46
+    mov AL, strict byte 04ah                  ; b0 4a
     mov dx, strict word 0000bh                ; ba 0b 00
     out DX, AL                                ; ee
@@ -3949,11 +4124,10 @@
     mov dx, strict word 0000ah                ; ba 0a 00
     out DX, AL                                ; ee
-    out DX, AL                                ; ee
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 02c69h                               ; e8 78 fb
-    mov AL, strict byte 0e6h                  ; b0 e6
+    call 02c7eh                               ; e8 29 fa
+    mov AL, strict byte 0c5h                  ; b0 c5
     mov dx, 003f5h                            ; ba f5 03
     out DX, AL                                ; ee
-    movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
+    movzx dx, byte [bp-008h]                  ; 0f b6 56 f8
     sal dx, 002h                              ; c1 e2 02
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
@@ -3961,7 +4135,7 @@
     mov dx, 003f5h                            ; ba f5 03
     out DX, AL                                ; ee
+    mov al, byte [bp-006h]                    ; 8a 46 fa
+    out DX, AL                                ; ee
     mov al, byte [bp-008h]                    ; 8a 46 f8
-    out DX, AL                                ; ee
-    mov al, byte [bp-006h]                    ; 8a 46 fa
     out DX, AL                                ; ee
     mov al, byte [bp-00ah]                    ; 8a 46 f6
@@ -3979,14 +4153,7 @@
     mov AL, strict byte 0ffh                  ; b0 ff
     out DX, AL                                ; ee
-    call 02bf8h                               ; e8 c9 fa
+    call 02c0dh                               ; e8 7a f9
     test al, al                               ; 84 c0
-    jne short 03147h                          ; 75 14
-    call 02c3eh                               ; e8 08 fb
-    mov ax, word [bp+016h]                    ; 8b 46 16
-    xor ah, ah                                ; 30 e4
-    or ah, 080h                               ; 80 cc 80
-    mov word [bp+016h], ax                    ; 89 46 16
-    mov ax, 00080h                            ; b8 80 00
-    jmp near 030a3h                           ; e9 5c ff
+    je near 03146h                            ; 0f 84 ad fe
     mov dx, 003f4h                            ; ba f4 03
     in AL, DX                                 ; ec
